# mypy-boto3-servicecatalog-appregistry

[![PyPI - mypy-boto3-servicecatalog-appregistry](https://img.shields.io/pypi/v/mypy-boto3-servicecatalog-appregistry.svg?color=blue)](https://pypi.org/project/mypy-boto3-servicecatalog-appregistry)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-servicecatalog-appregistry.svg?color=blue)](https://pypi.org/project/mypy-boto3-servicecatalog-appregistry)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-servicecatalog-appregistry?color=blue)](https://pypistats.org/packages/mypy-boto3-servicecatalog-appregistry)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.AppRegistry 1.17.57](https://boto3.amazonaws.com/v1/documentation/api/1.17.57/reference/services/servicecatalog-appregistry.html#AppRegistry) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.6.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-servicecatalog-appregistry](#mypy-boto3-servicecatalog-appregistry)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `AppRegistry` service.

```bash
python -m pip install boto3-stubs[servicecatalog-appregistry]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[servicecatalog-appregistry]` in your environment: `python -m pip install 'boto3-stubs[servicecatalog-appregistry]'`

Both type checking and auto-complete should work for `AppRegistry` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[servicecatalog-appregistry]` in your environment: `python -m pip install 'boto3-stubs[servicecatalog-appregistry]'`

Both type checking and auto-complete should work for `AppRegistry` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[servicecatalog-appregistry]` in your environment: `python -m pip install 'boto3-stubs[servicecatalog-appregistry]'`
- Run `mypy` as usual

Type checking should work for `AppRegistry` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[servicecatalog-appregistry]` in your environment: `python -m pip install 'boto3-stubs[servicecatalog-appregistry]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `AppRegistry` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`AppRegistryClient` provides annotations for `boto3.client("servicecatalog-appregistry")`.

```python
import boto3

from mypy_boto3_servicecatalog_appregistry import AppRegistryClient

client: AppRegistryClient = boto3.client("servicecatalog-appregistry")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AppRegistryClient = session.client("servicecatalog-appregistry")
```

### Paginators annotations

`mypy_boto3_servicecatalog_appregistry.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_servicecatalog_appregistry import AppRegistryClient
from mypy_boto3_servicecatalog_appregistry.paginator import (
    ListApplicationsPaginator,
    ListAssociatedAttributeGroupsPaginator,
    ListAssociatedResourcesPaginator,
    ListAttributeGroupsPaginator,
)

client: AppRegistryClient = boto3.client("servicecatalog-appregistry")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_applications_paginator: ListApplicationsPaginator = client.get_paginator("list_applications")
list_associated_attribute_groups_paginator: ListAssociatedAttributeGroupsPaginator = client.get_paginator("list_associated_attribute_groups")
list_associated_resources_paginator: ListAssociatedResourcesPaginator = client.get_paginator("list_associated_resources")
list_attribute_groups_paginator: ListAttributeGroupsPaginator = client.get_paginator("list_attribute_groups")
```







### Typed dictionations

`mypy_boto3_servicecatalog_appregistry.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_servicecatalog_appregistry.type_defs import (
    ApplicationSummaryTypeDef,
    ApplicationTypeDef,
    AttributeGroupSummaryTypeDef,
    AttributeGroupTypeDef,
    ResourceInfoTypeDef,
    AssociateAttributeGroupResponseTypeDef,
    AssociateResourceResponseTypeDef,
    CreateApplicationResponseTypeDef,
    CreateAttributeGroupResponseTypeDef,
    DeleteApplicationResponseTypeDef,
    DeleteAttributeGroupResponseTypeDef,
    DisassociateAttributeGroupResponseTypeDef,
    DisassociateResourceResponseTypeDef,
    GetApplicationResponseTypeDef,
    GetAttributeGroupResponseTypeDef,
    ListApplicationsResponseTypeDef,
    ListAssociatedAttributeGroupsResponseTypeDef,
    ListAssociatedResourcesResponseTypeDef,
    ListAttributeGroupsResponseTypeDef,
    ListTagsForResourceResponseTypeDef,
    PaginatorConfigTypeDef,
    SyncResourceResponseTypeDef,
    UpdateApplicationResponseTypeDef,
    UpdateAttributeGroupResponseTypeDef,
)

def get_structure() -> ApplicationSummaryTypeDef:
    return {
      ...
    }
```
